% Constants
simulationDataPath = 'G:\eclipse\eclipse\ganymede\workspace\XTeamSimulator';
modelFilePath = 'F:\Documents and Settings\Administrator\Desktop\RESIST\ConfigurationReliabilityAnalyzer\initial_estimations';

% Read the simulation data
controllerData1 = dlmread([simulationDataPath '\Robot5_Controller.txt']);
navigatorData1 = dlmread([simulationDataPath '\Robot5_Navigator1_Controller.txt']);

% Calculate Each Component's Reliability
Comm_In = 1;
TS1 = 1;
TS2 = 1;
C = calculateComponentReliability_controller(controllerData1, [1,0,0,0,0], [modelFilePath '\Controller' ]);
HS1 = 1;
HS2 = 1; 
PS1 = 1; 
PS2 = 1;
N = calculateComponentReliability_navigator(navigatorData1, [1,0,0,0], [modelFilePath '\Navigator1' ]);
A = 1;
Comm_Out = 1;

% Calculate System Reliability

% S1 : Comm_In
% S2 : TS1
% S3 : TS2
% S4 : C
% S5 : HS1, HS2, PS1, PS2
% S6 : N
% S7 : A
% S8 : Comm_Out

% Calculate transition probabilities
P14 = 1;
P24 = 1;
P34 = 1;

[P45, P46, P47, P48] = transitionProbability_controller(controllerData1);

P54 = 1;
P64 = 1;
P74 = 1;

% M
S1_S4 = Comm_In*P14;
S2_S4 = TS1*P24;
S3_S4 = TS2*P34;

S4_S5 = C*P45;
S5_S4 = HS1*HS2*PS1*PS2*P54;

S4_S6 = C*P46;
S6_S4 = N*P64;

S4_S7 = C*P47;
S7_S4 = A*P74;

S4_S8 = C*P48;

M   =   [   0       0       0       S1_S4   0       0       0       0       
            0       0       0       S2_S4   0       0       0       0       
            0       0       0       S3_S4   0       0       0       0       
            0       0       0       0       S4_S5   S4_S6   S4_S7   S4_S8   
            0       0       0       S5_S4   0       0       0       0       
            0       0       0       S6_S4   0       0       0       0       
            0       0       0       S7_S4   0       0       0       0
            0       0       0       0       0       0       0       0       ]


IM = eye(8,8) - M;
DET_IM = det(IM);


E = IM(1:7,2:8);
DET_E = det(E);

C
N
systemReliability = (-1)^9 * Comm_Out * (DET_E / DET_IM)

observedReliability = calculateObservedReliability_system(controllerData1)

req = 1;
resp = 3;
data = navigatorData1;

t1 = 0;
t2 = 0;
t3 = 0;
t4 = 0;

rows = size(data,1);
columns = size(data,2);
x = columns;
for i = 1 : rows
    for j = 1 : columns
        if (data(i,j) == req)
            t1 = t1 + 1;
        elseif (data(i,j) == resp)
            t2 = t2 + 1;
        end
    end
end

NavigatorObserved = t2 / t1